# BinaryHeaps.jl

[![Build Status](https://github.com/SciML/BinaryHeaps.jl/workflows/CI/badge.svg)](https://github.com/SciML/BinaryHeaps.jl/actions?query=workflow%3ACI)

Lightweight binary heap implementation extracted from
[DataStructures.jl](https://github.com/JuliaCollections/DataStructures.jl)
to minimize method invalidations.

Loading the full `DataStructures` package causes significant method invalidations
that slow down first-call latency in downstream packages. `BinaryHeaps.jl`
provides the same `BinaryHeap`, `BinaryMinHeap`, `BinaryMaxHeap`, and
`FasterForward`/`FasterReverse` types with zero invalidation overhead.

## Installation

```julia
using Pkg
Pkg.add("BinaryHeaps")
```

## Usage

```julia
using BinaryHeaps

# Min-heap
h = BinaryMinHeap{Int}()
push!(h, 5)
push!(h, 3)
push!(h, 1)
first(h)  # 1
pop!(h)   # 1

# Max-heap
h = BinaryMaxHeap{Int}()

# Heap from vector
h = BinaryMinHeap([5, 3, 7, 1, 9, 2])

# FasterForward for NaN-free float data (2x faster comparison)
h = BinaryHeap{Float64}(FasterForward())

# Array-based heap operations
xs = [5, 3, 7, 1]
heapify!(xs)
heappush!(xs, 2)
heappop!(xs)  # 1

# N largest/smallest
nsmallest(3, [5, 3, 7, 1, 9])  # [1, 3, 5]
nlargest(3, [5, 3, 7, 1, 9])   # [9, 7, 5]
```

## Attribution

The heap implementation is extracted from
[DataStructures.jl](https://github.com/JuliaCollections/DataStructures.jl)
(Copyright (c) 2013 Dahua Lin, MIT License).

# Generic heap functions
# Extracted from DataStructures.jl — Copyright (c) 2013 Dahua Lin, MIT License.

"""
    extract_all!(h)

Return an array of heap elements in sorted order (heap head at first index).
"""
function extract_all!(h::AbstractHeap{VT}) where {VT}
    n = length(h)
    r = Vector{VT}(undef, n)
    for i in 1:n
        r[i] = pop!(h)
    end
    return r
end

"""
    extract_all_rev!(h)

Return an array of heap elements in reverse sorted order (heap head at last index).
"""
function extract_all_rev!(h::AbstractHeap{VT}) where {VT}
    n = length(h)
    r = Vector{VT}(undef, n)
    for i in 1:n
        r[n + 1 - i] = pop!(h)
    end
    return r
end

"""
    nextreme(ord, n, arr)

Return an array of the first `n` values of `arr` sorted by `ord`.
"""
function nextreme(ord::Base.Order.Ordering, n::Int, arr::AbstractVector{T}) where {T}
    Base.require_one_based_indexing(arr)
    if n <= 0
        return T[]
    elseif n >= length(arr)
        return sort(arr; order = ord)
    end

    rev = Base.Order.ReverseOrdering(ord)
    buffer = heapify!(arr[1:n], rev)

    @inbounds for i in (n + 1):length(arr)
        xi = arr[i]
        if Base.Order.lt(rev, buffer[1], xi)
            buffer[1] = xi
            percolate_down!(buffer, 1, rev)
        end
    end

    return sort!(buffer; order = ord)
end

"""
    nlargest(n, arr; kw...)

Return the `n` largest elements of the array `arr`.
"""
function nlargest(n::Int, arr::AbstractVector; lt = isless, by = identity)
    order = Base.Order.ReverseOrdering(Base.Order.ord(lt, by, nothing))
    return nextreme(order, n, arr)
end

"""
    nsmallest(n, arr; kw...)

Return the `n` smallest elements of the array `arr`.
"""
function nsmallest(n::Int, arr::AbstractVector; lt = isless, by = identity)
    order = Base.Order.ord(lt, by, nothing)
    return nextreme(order, n, arr)
end

# Binary heap (non-mutable)
# Extracted from DataStructures.jl — Copyright (c) 2013 Dahua Lin, MIT License.

#################################################
#
#   Ordering types for faster float comparison
#
#################################################

"""
    FasterForward()

Enables 2x faster float comparison versus `Base.Order.ForwardOrdering`,
but ordering is undefined if the data contains NaN values.
"""
struct FasterForward <: Base.Order.Ordering end
Base.Order.lt(::FasterForward, a, b) = a < b

"""
    FasterReverse()

Enables 2x faster float comparison versus `Base.Order.ReverseOrdering`,
but ordering is undefined if the data contains NaN values.
"""
struct FasterReverse <: Base.Order.Ordering end
Base.Order.lt(::FasterReverse, a, b) = a > b

#################################################
#
#   heap type and constructors
#
#################################################

"""
    BinaryHeap{T, O <: Base.Order.Ordering} <: AbstractHeap{T}
    BinaryHeap{T}(ordering::Base.Order.Ordering)
    BinaryHeap{T}(ordering::Base.Order.Ordering, xs::AbstractVector)
    BinaryHeap(ordering::Base.Order.Ordering, xs::AbstractVector{T})

Binary heap storing values of type `T` according to ordering `O`.

# Type Parameters

- `T`: Element type stored by the heap.
- `O`: Ordering type used to compare heap elements.

# Fields

- `ordering`: Ordering used to compare heap elements.
- `valtree`: One-based array storing the heap tree.

# Examples

```julia
using BinaryHeaps

h = BinaryHeap{Int}(Base.Order.Forward)
push!(h, 3)
push!(h, 1)
pop!(h) # returns 1
```
"""
mutable struct BinaryHeap{T, O <: Base.Order.Ordering} <: AbstractHeap{T}
    ordering::O
    valtree::Vector{T}

    function BinaryHeap{T}(ordering::Base.Order.Ordering) where {T}
        return new{T, typeof(ordering)}(ordering, Vector{T}())
    end

    function BinaryHeap{T}(ordering::Base.Order.Ordering, xs::AbstractVector) where {T}
        valtree = heapify(xs, ordering)
        return new{T, typeof(ordering)}(ordering, valtree)
    end
end

function BinaryHeap(ordering::Base.Order.Ordering, xs::AbstractVector{T}) where {T}
    return BinaryHeap{T}(ordering, xs)
end

# Constructors using singleton order types as type parameters rather than arguments
BinaryHeap{T, O}() where {T, O <: Base.Order.Ordering} = BinaryHeap{T}(O())
function BinaryHeap{T, O}(xs::AbstractVector) where {T, O <: Base.Order.Ordering}
    return BinaryHeap{T}(O(), xs)
end

# These constructors needed for BinaryMaxHeap,
# until we have https://github.com/JuliaLang/julia/pull/37822
BinaryHeap{T, DefaultReverseOrdering}() where {T} = BinaryHeap{T}(Base.Order.Reverse)
function BinaryHeap{T, DefaultReverseOrdering}(xs::AbstractVector) where {T}
    return BinaryHeap{T}(Base.Order.Reverse, xs)
end

"""
    BinaryMinHeap{T}
    BinaryMinHeap{T}()
    BinaryMinHeap{T}(xs::AbstractVector)
    BinaryMinHeap(xs::AbstractVector{T})

Alias for [`BinaryHeap`](@ref) using `Base.Order.ForwardOrdering`, so the smallest
element is at the top of the heap.

# Type Parameters

- `T`: Element type stored by the heap.
"""
const BinaryMinHeap{T} = BinaryHeap{T, Base.Order.ForwardOrdering}

"""
    BinaryMaxHeap{T}
    BinaryMaxHeap{T}()
    BinaryMaxHeap{T}(xs::AbstractVector)
    BinaryMaxHeap(xs::AbstractVector{T})

Alias for [`BinaryHeap`](@ref) using reverse ordering, so the largest element is
at the top of the heap.

# Type Parameters

- `T`: Element type stored by the heap.
"""
const BinaryMaxHeap{T} = BinaryHeap{T, DefaultReverseOrdering}

BinaryMinHeap(xs::AbstractVector{T}) where {T} = BinaryMinHeap{T}(xs)
BinaryMaxHeap(xs::AbstractVector{T}) where {T} = BinaryMaxHeap{T}(xs)

#################################################
#
#   interfaces
#
#################################################

"""
    length(h::BinaryHeap)

Returns the number of elements in heap `h`.
"""
Base.length(h::BinaryHeap) = length(h.valtree)

"""
    isempty(h::BinaryHeap)

Returns whether the heap `h` is empty.
"""
Base.isempty(h::BinaryHeap) = isempty(h.valtree)

"""
    push!(h::BinaryHeap, value)

Adds the `value` element to the heap `h`.
"""
@inline function Base.push!(h::BinaryHeap, v)
    heappush!(h.valtree, v, h.ordering)
    return h
end

"""
    first(h::BinaryHeap)

Returns the element at the top of the heap `h`.
"""
@inline Base.first(h::BinaryHeap) = h.valtree[1]

"""
    pop!(h::BinaryHeap)

Removes and returns the element at the top of the heap `h`.
"""
Base.pop!(h::BinaryHeap) = heappop!(h.valtree, h.ordering)

function Base.empty!(h::BinaryHeap)
    empty!(h.valtree)
    return h
end

function Base.sizehint!(h::BinaryHeap, n::Integer)
    sizehint!(h.valtree, n)
    return h
end

# Tests extracted from DataStructures.jl
# Copyright (c) 2013 Dahua Lin, MIT License.

using BinaryHeaps
using Test

@testset "BinaryHeaps.jl" begin
    @testset "BinaryHeaps" begin
        @testset "make heap" begin
            vs = [4, 1, 3, 2, 16, 9, 10, 14, 8, 7]
            vs2 = collect(enumerate(vs))
            ordering = Base.Order.By(last)

            @testset "construct heap" begin
                BinaryHeap{Int, Base.ForwardOrdering}()
                BinaryHeap{Int, Base.ForwardOrdering}(vs)

                BinaryHeap{Int, Base.ReverseOrdering}()
                BinaryHeap{Int, Base.ReverseOrdering}(vs)

                BinaryMinHeap{Int}()
                BinaryMinHeap{Int}(vs)
                BinaryMinHeap(vs)

                BinaryMaxHeap{Int}()
                BinaryMaxHeap{Int}(vs)
                BinaryMaxHeap(vs)

                BinaryHeap{eltype(vs2)}(ordering)
                BinaryHeap{eltype(vs2)}(ordering, vs2)
                BinaryHeap(ordering, vs2)

                @test true
            end

            @testset "Type Aliases" begin
                @test BinaryMaxHeap{Int}() isa BinaryMaxHeap{Int}
                @test BinaryMinHeap{Int}() isa BinaryMinHeap{Int}
            end

            @testset "implicit conversion" begin
                @test BinaryHeap{Float64, Base.ForwardOrdering}(vs) isa
                    BinaryHeap{Float64, Base.ForwardOrdering}
                @test BinaryMinHeap{Float64}(vs) isa BinaryMinHeap{Float64}
                @test BinaryMaxHeap{Float64}(vs) isa BinaryMaxHeap{Float64}
                @test BinaryHeap{Tuple{Int, Float64}}(ordering, vs2) isa
                    BinaryHeap{Tuple{Int, Float64}}
            end

            @testset "confirm heap" begin
                @test isheap([1, 2, 3, 4, 7, 9, 10, 14, 8, 16])
                @test isheap([16, 14, 10, 8, 7, 3, 9, 1, 4, 2], Base.Reverse)

                @test !isheap([16, 14, 10, 8, 7, 3, 9, 1, 4, 2])
                @test !isheap([1, 2, 3, 4, 7, 9, 10, 14, 8, 16], Base.Reverse)
                @test !isheap([15, 2, 3, 4, 7, 9, 10, 14, 8, 16])
                @test !isheap([15, 2, 3, 4, 7, 9, 10, 14, 8, 16], Base.Reverse)
            end

            @testset "make min heap" begin
                h = BinaryMinHeap(vs)

                @test length(h) == 10
                @test !isempty(h)
                @test first(h) == 1
                @test isheap([1, 2, 3, 4, 7, 9, 10, 14, 8, 16])
                @test sizehint!(h, 100) === h
            end

            @testset "make max heap" begin
                h = BinaryMaxHeap(vs)

                @test length(h) == 10
                @test !isempty(h)
                @test first(h) == 16
                @test isheap([16, 14, 10, 8, 7, 3, 9, 1, 4, 2], Base.Reverse)
                @test sizehint!(h, 100) === h
            end

            @testset "make custom ordering heap" begin
                h = BinaryHeap(ordering, vs2)

                @test length(h) == 10
                @test !isempty(h)
                @test first(h) == (2, 1)
                @test isheap(
                    [
                        (2, 1), (4, 2), (3, 3), (1, 4), (10, 7), (6, 9), (7, 10),
                        (8, 14), (9, 8), (5, 16),
                    ],
                    ordering
                )
                @test sizehint!(h, 100) === h
            end

            @testset "extract all" begin
                @test sort(vs) == extract_all!(BinaryMinHeap(vs))
                @test reverse(sort(vs)) == extract_all_rev!(BinaryMinHeap(vs))
            end

            @testset "push!" begin
                @testset "push! hmin" begin
                    hmin = BinaryMinHeap{Int}()
                    @test length(hmin) == 0
                    @test isempty(hmin)

                    ss = Any[
                        [4],
                        [1, 4],
                        [1, 4, 3],
                        [1, 2, 3, 4],
                        [1, 2, 3, 4, 16],
                        [1, 2, 3, 4, 16, 9],
                        [1, 2, 3, 4, 16, 9, 10],
                        [1, 2, 3, 4, 16, 9, 10, 14],
                        [1, 2, 3, 4, 16, 9, 10, 14, 8],
                        [1, 2, 3, 4, 7, 9, 10, 14, 8, 16],
                    ]

                    for i in 1:length(vs)
                        push!(hmin, vs[i])
                        @test length(hmin) == i
                        @test !isempty(hmin)
                        @test isequal(hmin.valtree, ss[i])
                    end

                    @testset "pop! hmin" begin
                        @test isequal(
                            extract_all!(hmin),
                            [1, 2, 3, 4, 7, 8, 9, 10, 14, 16]
                        )
                        @test isempty(hmin)
                    end
                end

                @testset "push! hmax" begin
                    hmax = BinaryMaxHeap{Int}()
                    @test length(hmax) == 0
                    @test isempty(hmax)

                    ss = Any[
                        [4],
                        [4, 1],
                        [4, 1, 3],
                        [4, 2, 3, 1],
                        [16, 4, 3, 1, 2],
                        [16, 4, 9, 1, 2, 3],
                        [16, 4, 10, 1, 2, 3, 9],
                        [16, 14, 10, 4, 2, 3, 9, 1],
                        [16, 14, 10, 8, 2, 3, 9, 1, 4],
                        [16, 14, 10, 8, 7, 3, 9, 1, 4, 2],
                    ]

                    for i in 1:length(vs)
                        push!(hmax, vs[i])
                        @test length(hmax) == i
                        @test !isempty(hmax)
                        @test isequal(hmax.valtree, ss[i])
                    end

                    @testset "pop! hmax" begin
                        @test isequal(
                            extract_all!(hmax),
                            [16, 14, 10, 9, 8, 7, 4, 3, 2, 1]
                        )
                        @test isempty(hmax)
                    end
                end

                @testset "push! custom ordering" begin
                    heap = BinaryHeap{Tuple{Int, Int}}(ordering)
                    @test length(heap) == 0
                    @test isempty(heap)

                    ss = Any[
                        [(1, 4)],
                        [(2, 1), (1, 4)],
                        [(2, 1), (1, 4), (3, 3)],
                        [(2, 1), (4, 2), (3, 3), (1, 4)],
                        [(2, 1), (4, 2), (3, 3), (1, 4), (5, 16)],
                        [(2, 1), (4, 2), (3, 3), (1, 4), (5, 16), (6, 9)],
                        [(2, 1), (4, 2), (3, 3), (1, 4), (5, 16), (6, 9), (7, 10)],
                        [
                            (2, 1), (4, 2), (3, 3), (1, 4), (5, 16), (6, 9), (7, 10),
                            (8, 14),
                        ],
                        [
                            (2, 1), (4, 2), (3, 3), (1, 4), (5, 16), (6, 9), (7, 10),
                            (8, 14), (9, 8),
                        ],
                        [
                            (2, 1), (4, 2), (3, 3), (1, 4), (10, 7), (6, 9), (7, 10),
                            (8, 14), (9, 8), (5, 16),
                        ],
                    ]

                    for i in 1:length(vs2)
                        push!(heap, vs2[i])
                        @test length(heap) == i
                        @test !isempty(heap)
                        @test isequal(heap.valtree, ss[i])
                    end

                    @testset "pop! custom ordering" begin
                        @test isequal(
                            extract_all!(heap),
                            sort(vs2; order = ordering)
                        )
                        @test isempty(heap)
                    end
                end
            end
        end

        @testset "hybrid push! and pop!" begin
            h = BinaryMinHeap{Int}()

            @testset "push1" begin
                push!(h, 5)
                push!(h, 10)
                @test isequal(h.valtree, [5, 10])
            end

            @testset "pop1" begin
                @test pop!(h) == 5
                @test isequal(h.valtree, [10])
            end

            @testset "push2" begin
                push!(h, 7)
                push!(h, 2)
                @test isequal(h.valtree, [2, 10, 7])
            end

            @testset "pop2" begin
                @test pop!(h) == 2
                @test isequal(h.valtree, [7, 10])
            end
        end

        @testset "nlargest and nsmallest" begin
            ss = [
                100, 103, -12, -109, 67, 4, 65, -52, -97, -32, -24, 114, -128,
                102, -56, -17, -41, 25, -30, -84, 26, -84, 48, 49, -5, -38, 28,
                114, -54, 96, -55, 67, 74, 127, -61, 124, 11, -7, 93, -51, 110,
                -106, -84, -90, -18, -12, -116, 21, 115, 50,
            ]
            square = x -> x^2

            for n in -1:(length(ss) + 1)
                r = 1:min(n, length(ss))

                @test nlargest(n, ss) == sort(ss; rev = true)[r]
                @test nsmallest(n, ss) == sort(ss)[r]

                @test nlargest(n, ss; by = square) ==
                    sort(ss; by = square, rev = true)[r]
                @test nsmallest(n, ss; by = square) == sort(ss; by = square)[r]

                @test nlargest(n, ss) == nextreme(FasterReverse(), n, ss)
                @test nsmallest(n, ss) == nextreme(FasterForward(), n, ss)
            end
        end

        @testset "push! type conversion" begin # issue 399
            h = BinaryMinHeap{Float64}()
            push!(h, 3.0)
            push!(h, 5)
            push!(h, Rational(4, 8))
            push!(h, Complex(10.1, 0.0))

            @test isequal(h.valtree, [0.5, 5.0, 3.0, 10.1])
        end

        @testset "empty!" begin
            vs = [4, 1, 3, 2, 16, 9, 10, 14, 8, 7]
            vs2 = collect(enumerate(vs))
            ordering = Base.Order.By(last)

            for h in
                (BinaryMinHeap(vs), BinaryMaxHeap(vs), BinaryHeap(ordering, vs2))
                @test length(h) == length(vs)
                @test !isempty(h)
                ret = empty!(h)
                @test ret === h
                @test length(ret) == 0
                @test isempty(ret)
            end
        end
    end

    @testset "Low-level heap operations" begin
        @testset "heapify! and heappop!" begin
            xs = heapify!([v for v in 10:-1:1])
            @test issorted([heappop!(xs) for _ in 1:10])
        end

        @testset "heapify/issorted" begin
            xs = heapify(10:-1:1)
            @test issorted([heappop!(xs) for _ in 1:10])
        end

        @testset "heappush!" begin
            xs = Vector{Int}()
            for v in [4, 1, 3, 2, 16, 9, 10, 14, 8, 7]
                heappush!(xs, v)
            end
            @test issorted([heappop!(xs) for _ in 1:10])
        end

        @testset "isheap" begin
            @test isheap([1, 2, 3], Base.Order.Forward)
            @test !isheap([1, 2, 3], Base.Order.Reverse)
        end

        @testset "percolate_down!" begin
            @testset "Basic percolate down" begin
                xs = [10, 2, 3, 4, 5]
                BinaryHeaps.percolate_down!(xs, 1, 10, Base.Order.Forward)
                @test xs == [2, 4, 3, 10, 5]
            end

            @testset "Element in correct position" begin
                xs = [1, 2, 3, 4, 5]
                BinaryHeaps.percolate_down!(xs, 1, 1, Base.Order.Forward)
                @test xs == [1, 2, 3, 4, 5]
            end

            @testset "Reverse ordering" begin
                xs = [1, 5, 4, 3, 2]
                BinaryHeaps.percolate_down!(xs, 1, 1, Base.Order.Reverse)
                @test xs == [5, 3, 4, 1, 2]
            end

            @testset "Custom length" begin
                xs = [10, 2, 3, 4, 5]
                BinaryHeaps.percolate_down!(xs, 1, 10, Base.Order.Forward, 3)
                @test xs == [2, 10, 3, 4, 5]
            end

            @testset "Without explicit x parameter" begin
                xs = [10, 2, 3, 4, 5]
                BinaryHeaps.percolate_down!(xs, 1, Base.Order.Forward)
                @test xs == [2, 4, 3, 10, 5]

                xs = [10, 2, 3, 4, 5]
                BinaryHeaps.percolate_down!(xs, 1)
                @test xs == [2, 4, 3, 10, 5]
            end

            @testset "From middle position" begin
                xs = [2, 0, 3, 4, 5]
                BinaryHeaps.percolate_down!(xs, 2, 10, Base.Order.Forward)
                @test xs == [2, 4, 3, 10, 5]
            end
        end

        @testset "percolate_up!" begin
            @testset "Basic percolate up" begin
                xs = [1, 2, 3, 4, 0]
                BinaryHeaps.percolate_up!(xs, 5, 0, Base.Order.Forward)
                @test xs == [0, 1, 3, 4, 2]
            end

            @testset "Element in correct position" begin
                xs = [1, 2, 3, 4, 5]
                BinaryHeaps.percolate_up!(xs, 5, 5, Base.Order.Forward)
                @test xs == [1, 2, 3, 4, 5]
            end

            @testset "Reverse ordering" begin
                xs = [5, 4, 3, 2, 10]
                BinaryHeaps.percolate_up!(xs, 5, 10, Base.Order.Reverse)
                @test xs == [10, 5, 3, 2, 4]
            end

            @testset "Percolate to root" begin
                xs = [2, 3, 4, 5, 1]
                BinaryHeaps.percolate_up!(xs, 5, 1, Base.Order.Forward)
                @test xs == [1, 2, 4, 5, 3]
            end

            @testset "Without explicit x parameter" begin
                xs = [1, 2, 3, 4, 0]
                BinaryHeaps.percolate_up!(xs, 5, Base.Order.Forward)
                @test xs == [0, 1, 3, 4, 2]

                xs = [1, 2, 3, 4, 0]
                BinaryHeaps.percolate_up!(xs, 5)
                @test xs == [0, 1, 3, 4, 2]
            end

            @testset "From middle position" begin
                xs = [1, 5, 3, 10, 8]
                BinaryHeaps.percolate_up!(xs, 4, 0, Base.Order.Forward)
                @test xs == [0, 1, 3, 5, 8]
            end
        end
    end

    @testset "eltype" begin
        h = BinaryMinHeap{Float64}()
        @test eltype(h) == Float64
        @test eltype(typeof(h)) == Float64
    end
end

# This contains code that was formerly a part of Julia. License is MIT: http://julialang.org/license
# Extracted from DataStructures.jl — Copyright (c) 2013 Dahua Lin, MIT License.

# Heap operations on flat arrays
# ------------------------------

# Binary heap indexing
"""
    heapleft(i::Integer)

Return the one-based array index of the left child of heap node `i`.

# Arguments

- `i`: One-based heap node index.

# Returns

The one-based index of the left child.
"""
heapleft(i::Integer) = 2i

"""
    heapright(i::Integer)

Return the one-based array index of the right child of heap node `i`.

# Arguments

- `i`: One-based heap node index.

# Returns

The one-based index of the right child.
"""
heapright(i::Integer) = 2i + 1

"""
    heapparent(i::Integer)

Return the one-based array index of the parent of heap node `i`.

# Arguments

- `i`: One-based heap node index.

# Returns

The one-based index of the parent node.
"""
heapparent(i::Integer) = div(i, 2)

# Binary min-heap percolate down.
Base.@propagate_inbounds function percolate_down!(
        xs::AbstractArray, i::Integer, x,
        o::Ordering = Forward, len::Integer = length(xs)
    )
    @boundscheck checkbounds(xs, i)
    @boundscheck checkbounds(xs, len)

    @inbounds while (l = heapleft(i)) <= len
        r = heapright(i)
        j = r > len || lt(o, xs[l], xs[r]) ? l : r
        lt(o, xs[j], x) || break
        xs[i] = xs[j]
        i = j
    end
    return @inbounds xs[i] = x
end
Base.@propagate_inbounds function percolate_down!(
        xs::AbstractArray, i::Integer,
        o::Ordering = Forward, len::Integer = length(xs)
    )
    return percolate_down!(xs, i, xs[i], o, len)
end

# Binary min-heap percolate up.
Base.@propagate_inbounds function percolate_up!(
        xs::AbstractArray, i::Integer, x,
        o::Ordering = Forward
    )
    @boundscheck checkbounds(xs, i)

    @inbounds while (j = heapparent(i)) >= 1
        lt(o, x, xs[j]) || break
        xs[i] = xs[j]
        i = j
    end
    return @inbounds xs[i] = x
end
Base.@propagate_inbounds function percolate_up!(
        xs::AbstractArray, i::Integer,
        o::Ordering = Forward
    )
    return percolate_up!(xs, i, xs[i], o)
end

"""
    heappop!(v, [ord])

Given a binary heap-ordered array, remove and return the lowest ordered element.
For efficiency, this function does not check that the array is indeed heap-ordered.
"""
function heappop!(xs::AbstractArray, o::Ordering = Forward)
    Base.require_one_based_indexing(xs)
    x = xs[1]
    y = pop!(xs)
    if !isempty(xs)
        @inbounds percolate_down!(xs, 1, y, o)
    end
    return x
end

"""
    heappush!(v, x, [ord])

Given a binary heap-ordered array, push a new element `x`, preserving the heap property.
For efficiency, this function does not check that the array is indeed heap-ordered.
"""
@inline function heappush!(xs::AbstractArray, x, o::Ordering = Forward)
    Base.require_one_based_indexing(xs)
    push!(xs, x)
    @inbounds percolate_up!(xs, length(xs), o)
    return xs
end

"""
    heapify!(v, ord::Ordering=Forward)

In-place [`heapify`](@ref).
"""
@inline function heapify!(xs::AbstractArray, o::Ordering = Forward)
    Base.require_one_based_indexing(xs)
    for i in heapparent(length(xs)):-1:1
        @inbounds percolate_down!(xs, i, o)
    end
    return xs
end

"""
    heapify(v, ord::Ordering=Forward)

Returns a new vector in binary heap order, optionally using the given ordering.
"""
heapify(xs::AbstractArray, o::Ordering = Forward) = heapify!(copyto!(similar(xs), xs), o)

"""
    isheap(v, ord::Ordering=Forward)

Return `true` if an array is heap-ordered according to the given order.
"""
function isheap(xs::AbstractArray, o::Ordering = Forward)
    Base.require_one_based_indexing(xs)
    for i in 1:div(length(xs), 2)
        if lt(o, xs[heapleft(i)], xs[i]) ||
                (heapright(i) <= length(xs) && lt(o, xs[heapright(i)], xs[i]))
            return false
        end
    end
    return true
end

using BinaryHeaps
using Documenter

makedocs(;
    modules = [BinaryHeaps],
    sitename = "BinaryHeaps.jl",
    pages = [
        "Home" => "index.md",
        "API" => "api.md",
    ],
    checkdocs = :exports,
    warnonly = false,
)

"""
    BinaryHeaps

Lightweight binary heap implementation extracted from
[DataStructures.jl](https://github.com/JuliaCollections/DataStructures.jl)
to avoid the invalidation overhead of the full DataStructures package.

Original code is Copyright (c) 2013 Dahua Lin, MIT License.
"""
module BinaryHeaps

using Base.Order: Forward, Ordering, lt

export AbstractHeap,
    BinaryHeap, BinaryMinHeap, BinaryMaxHeap,
    FasterForward, FasterReverse,
    extract_all!, extract_all_rev!,
    heapify!, heapify, isheap,
    heappush!, heappop!,
    heapleft, heapright, heapparent,
    nlargest, nsmallest, nextreme

"""
    AbstractHeap{T}

Abstract supertype for heap containers whose elements have type `T`.

# Type Parameters

- `T`: Element type stored by the heap.
"""
abstract type AbstractHeap{VT} end
Base.eltype(::Type{<:AbstractHeap{T}}) where {T} = T

const DefaultReverseOrdering = Base.Order.ReverseOrdering{Base.Order.ForwardOrdering}

include("arrays_as_heaps.jl")
include("binary_heap.jl")
include("generic.jl")

end # module

# API

```@docs
BinaryHeaps
AbstractHeap
BinaryHeap
BinaryMinHeap
BinaryMaxHeap
FasterForward
FasterReverse
extract_all!
extract_all_rev!
heapify!
heapify
isheap
heappush!
heappop!
heapleft
heapright
heapparent
nlargest
nsmallest
nextreme
```

# BinaryHeaps.jl

Lightweight binary heap implementation extracted from
[DataStructures.jl](https://github.com/JuliaCollections/DataStructures.jl) to
avoid the invalidation overhead of the full DataStructures package.

```@contents
Pages = ["api.md"]
Depth = 2
```
